/* Copyright (c) 2009 Nordic Semiconductor. All Rights Reserved.
 *
 * The information contained herein is confidential property of Nordic
 * Semiconductor ASA.Terms and conditions of usage are described in detail
 * in NORDIC SEMICONDUCTOR STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information. NO
 * WARRANTY of ANY KIND is provided. This heading must NOT be removed from
 * the file.
 *
 */

#include <stdbool.h>
#include <stdint.h>
#include "nrf.h"
#include "nrf_gpio.h"
#include "nrf_delay.h"
#include "boards.h"

#ifdef __ARMCC__
/* Keil */
static uint32_t test __attribute__( ( zero_init) ) __attribute__((at(0x20007000)));
#endif
#ifdef __GNUC__
/* GCC, see the .ld file for more details */ 
uint32_t test __attribute__((section(".no_init"))) __attribute__((used));
#endif
#ifdef __ICCARM__
/* IAR */
__root __no_init static volatile uint32_t test @ 0x20007000;
#endif

int main(void)
{
    // Configure the LED pins as outputs
    nrf_gpio_range_cfg_output(LED_START, LED_STOP);
    // Clear LEDs on DK, as they are active LOW
    nrf_gpio_pin_set(BSP_LED_0);
    nrf_gpio_pin_set(BSP_LED_1);
    nrf_gpio_pin_set(BSP_LED_2);
    nrf_gpio_pin_set(BSP_LED_3);
    nrf_delay_us(1000*1000);
    
    // Blink LED to verify that variable "test" is not zero.
    if (test > 0)
    {
        uint8_t led_state = test % 4;
        nrf_gpio_pin_toggle(BSP_LED_0 + led_state);               
        nrf_delay_us(100*1000);
    } 
    
    // If desired, change the RAM retention parameters:
    NRF_POWER->RAMON = POWER_RAMON_ONRAM0_RAM0On  << POWER_RAMON_ONRAM0_Pos
                     | POWER_RAMON_ONRAM1_RAM1On  << POWER_RAMON_ONRAM1_Pos
                     | POWER_RAMON_OFFRAM0_RAM0Off  << POWER_RAMON_OFFRAM0_Pos
                     | POWER_RAMON_OFFRAM1_RAM1Off  << POWER_RAMON_OFFRAM1_Pos;
    
    while(1)
    {     
        test++;
        NVIC_SystemReset();
        // Should not end up here, but just in case; hang tight.
        while(1);
    }
}
